/* Copyright  1988-1990 Apple Computer, Inc.  All rights reserved. */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Dialog.rsrc";

#define cMessagesWindow 1000
#define cNewWindow 1001
#define cStatusWindow 1002

#define cMarkAllRead 1003
#define cClearMessages 1004

#define cPreferences 1005

#define mWindows 4
#define mMessages 5

#define kSettingsFileSTR 1000
#define kNoExpirationSTR 1001

#define kStatStrings 1000

#define kLACSSettings 'rums'

include $$Shell("ObjApp")"LACS" 'CODE';

resource 'seg!' (256, purgeable) {
	{
		"GOpen";
		"GClose";
		"GNonRes";
		"GSelCommand";
		"GDoCommand"
	}
};

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	650 * 1024,
	550 * 1024
#else
	400 * 1024,
	350 * 1024
#endif
};

include "Defaults.rsrc" 'cmnu' (mApple);		// Grab the default Apple menu

resource 'cmnu' (mFile) {
	mFile,
	textMenuProc,
	0x7FFFFBBB,
	enabled,
	"File",
	{
		"Close Window",		noIcon, "W",	noMark, plain, cClose;
		"Preferences...",	noIcon, noKey,	noMark, plain, cPreferences;
		"Quit",				noIcon, "Q",	noMark, plain, cQuit
	}
};

resource 'cmnu' (mWindows) {
	mWindows,
	textMenuProc,
	allEnabled,
	enabled,
	"Windows",
	{
		"Messages",		noIcon, "R",	noMark, plain, cMessagesWindow;
		"New",			noIcon, "N",	noMark, plain, cNewWindow;
		"Status",		noIcon, "S",	noMark, plain, cStatusWindow
	}
};

resource 'cmnu' (mMessages) {
	mMessages,
	textMenuProc,
	allEnabled,
	enabled,
	"Messages",
	{
		"Mark All Messages Read",	noIcon, "M",	noMark, plain, cMarkAllRead;
		"Delete All Messages",		noIcon, "D",	noMark, plain, cClearMessages
	}
};

resource 'STR#' (kStatStrings,
#if qNames
"StatStrings",
#endif
	purgeable) {
		{
			"Bored and idle...";
			"Adding new message...";
			"Updating AppleTalk zone list...";
			"Updating LACS systems list...";
			"Initiating exchange...";
			"Exchanging messages..."
		}
};

resource 'STR ' (kSettingsFileSTR,
#if qNames
"SettingsFiles",
#endif
	purgeable) {
	"LACS Settings"
};

include "Defaults.rsrc" 'cmnu' (mEdit);		// Grab the default Edit menus

include "Defaults.rsrc" 'cmnu' (mBuzzwords);	// Get the default buzzwords menu

resource 'MBAR' (kMBarDisplayed) { {mApple; mFile; mEdit; mMessages; mWindows} };

resource 'BNDL' (128,
#if qNames
"Bundle",
#endif
	purgeable) {
	'rumo',
	0,
		{
		'ICN#',
			{
			0, 128,
			1, 129,
			},
		'FREF',
			{
			0, 128,
			1, 129,
			}
		}
};

resource 'FREF' (129,
#if qNames
"Settings",
#endif
	purgeable) {
	kLACSSettings,
	1,
	""
};

type 'rumo' as 'STR ';
resource 'rumo' (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"LACS 1.1"
};

// Get the default MacApp application icon and necessary bundling rsrcs
include "Defaults.rsrc"  'FREF' (128);

// Get the default Version resources
RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x01,
	final,
	0x00,
	verUs,
	"1.1",
	"LACS 1.1, Apple Computer, Inc. 1990"
};
include "Defaults.rsrc"  'vers' (2);		// Overall package

include "LACSRsrc.rsrc";
