/*

	Invert.r - Resources for the Invert fader
	
	copyright  1989 by Tom Dowdy
	All rights reserved
	
	
*/
#include "Types.r"


#define A			15		/* A = spacing around edge of dialog */
#define B			22		/* B = spacing around icon = A * 1.5 */
#define TextHeight	20		/* Height of the text in the dialog */
#define TextWidth	250		/* Width of the text in the dialog */

#define XStart		50								/* Start of dialog */
#define YStart		40								/* Start of dialog */
#define Width		A + TextWidth + A				/* Width of dialog */
#define Height		A + TextHeight + A + TextHeight + B + 20 + A		/* Height of dialog */

#define InterbuttonX 	10							/* Spacing between the buttons */

resource 'STR ' (10000) {
	"Invert  1990, 1991 by Tom Dowdy";
};

resource 'DITL' (10000) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{Height - A - 20, Width - A - 60, 
			Height - A, Width - A},
		Button {
			enabled,
			"OK"
		},
		/* [1] */
		{Height - A - 20, Width - A - 60 - 70, 
			Height - A, Width - A - 70},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{Height - A- 20-4, Width - A - 60-4, 
			Height - A+4, Width - A+4},
		UserItem {
			disabled
		},
		/* [4] */
		{A*2, A, A*2 + TextHeight, A + TextWidth},
		StaticText {
			disabled,
			"Invert Fader Settings"
		},
		
		{A+TextHeight + A, B, A+TextHeight + A + 16, B + TextWidth},
		CheckBox {
			enabled,
			"Invert screen during fade"
		},

		{0  , A, 0 + 16, A + TextWidth},
		UserItem {
			disabled
		},
		
	}
};

resource 'DLOG' (10000) {
	{YStart, XStart, YStart + Height, XStart + Width},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	10000,
	""
};
